Comments widget
The Comments widget is a component that displays a stream of comments.
It supports rendering in different styles and can display plain text or markdown formatted messages. The widget is capable of rendering existing comments and allows for adding, deleting, or editing previously created comments. It operates entirely on the client-side and can be integrated with any backend service.
This widget is licensed under the MIT license.
Quick start
First steps
To start with the widget, add the necessary package to your project first.
npm install @svar-ui/vue-core
npm install @svar-ui/vue-comments
or
yarn add @svar-ui/vue-core
yarn add @svar-ui/vue-comments
Now, import the widget into your project.
<script setup>
import { Willow } from '@svar-ui/vue-core';
import { Comments } from '@svar-ui/vue-comments';
</script>
<template>
<Willow>
<Comments />
</Willow>
</template>
The Willow component is a default theme wrapper that adds necessary styles for all SVAR widgets. The Comments component can function without it, but it will lack styles and require additional styling effort. It is recommended to add the Willow tag once at the top level of your application.
Full init code
To see the widget in action, add some comments to the widget.
<script setup>
import { Comments, Willow } from '@svar-ui/vue-comments';
const value = [
{
id: "1",
content: "Hello, world!",
user: 1,
date: new Date(),
},
];
const users = [
{ id: 1, name: "John Doe" },
{ id: 2, name: "Jane Doe" },
];
</script>
<template>
<Willow>
<Comments :value="value" :users="users" />
</Willow>
</template>
Make sure you apply a theme if you use the Comments component standalone. Please, refer to applying a theme for more information.
Visual themes
The widget is provided in two visual styles - Light and Dark, controlled by the theme tag.
<script setup>
import { Willow, WillowDark } from "@svar-ui/vue-core";
</script>
<template>
<!-- Light -->
<Willow>
<Comments />
</Willow>
<!-- Dark -->
<WillowDark>
<Comments />
</WillowDark>
</template>
Initialization
The widget provides several methods to initialize and load comments. It supports fetching comments from a backend API, rendering an empty widget, or initializing with predefined data and user information. These options allow flexibility in integrating the widget into different applications and use cases.
Initializing the widget and loading comments
<script setup>
import { ref, onMounted } from 'vue';
import { Comments } from '@svar-ui/vue-comments';
const value = ref([]);
onMounted(() => {
fetch('/api/comments')
.then(r => r.json())
.then(x => value.value = x);
});
</script>
<template>
<Comments :value="value" />
</template>
This approach initializes the widget by fetching comment data from a backend API. It is suitable when the comments are stored on a server and need to be loaded dynamically. The fetch function retrieves the comments in JSON format, which is then passed to the Comments component. The reactive ref ensures the comments are displayed once the data is successfully loaded.
Initializing an empty comments widget
<script setup>
import { Comments } from '@svar-ui/vue-comments';
</script>
<template>
<Comments />
</template>
This method initializes the widget without any preloaded comments. It is useful when the application starts with no existing comments, allowing users to add new comments from scratch. The component renders a clean interface with no prefilled data.
Initializing the widget with data and a list of users
<script setup>
import { Comments } from '@svar-ui/vue-comments';
const value = [
{
id: "1",
content: "Hello, world!",
user: 1,
date: new Date(),
},
];
const users = [
{ id: 1, name: "John Doe" },
{ id: 2, name: "Jane Doe" },
];
</script>
<template>
<Comments :value="value" :users="users" />
</template>
This option initializes the widget with predefined comments and a list of users. Each comment references a user by their ID, and the users array provides the user details. This setup is ideal when the application needs to display comments along with user information, such as names, but the user data is managed separately from the comment data.
Initializing the widget with data and embedded authors
<script setup>
import { Comments } from '@svar-ui/vue-comments';
const value = [
{
id: "1",
content: "Hello, world!",
author:{ id: 1, name: "John Doe" },
date: new Date(),
},
];
</script>
<template>
<Comments :value="value" />
</template>
This method initializes the widget with predefined comments where the author information is embedded directly within each comment. It is suitable when the application has a compact data structure where user details are stored as part of the comment object. This approach simplifies the data model by combining comments and author details into a single structure.
User interaction
The widget includes methods to handle user comments and interactions. It enables functionalities like defining the current user, auto-focusing the comments editor, tracking changes in data, and retrieving the list of comments.
Defining the current user
The widget allows specifying the currently active user. This is useful for scenarios where specific user comments need to be highlighted or given special permissions, such as editing or deleting. Comments from the active user can have distinct styling for better visual differentiation.
<script setup>
import { Comments } from '@svar-ui/vue-comments';
const users = [
{ id: 1, name: "John Doe" },
{ id: 2, name: "Jane Doe" },
];
</script>
<template>
<Comments :value="value" :users="users" :activeUser="1" />
</template>
In this example, the activeUser property is set to 1, indicating that the user with id: 1 is the current user. Their comments can be edited or deleted through the UI and can have separate styling applied to them.
Auto-focusing the comments Editor
The widget provides the ability to automatically focus the comments editor when it is rendered. This is particularly useful for use-cases where the widget is integrated into a page that prioritizes user input, such as a discussion forum or a feedback form.
<script setup>
import { Comments } from '@svar-ui/vue-comments';
</script>
<template>
<Comments :focus="true" />
</template>
By setting the focus property to true, the input field for adding a comment will be automatically focused after the widget is rendered.
Tracking data changes
The widget supports monitoring changes to the comments data. It provides detailed information about the type of change (add, update, or delete), the specific comment affected, and the state of the data before and after the change. This functionality is essential for implementing features like real-time updates, logging, or syncing with a backend.
interface OnChange {
// kind of change
action: "add" | "update" | "delete";
// id of changed comment
id?: number;
// changed comment
comment?: Comment;
// current comments data
data: Comment[];
// original comments data
originalValue: Comment[] | number | string;
}
<script setup>
import { Comments } from '@svar-ui/vue-comments';
import { value } from './data.js';
const onchange = ({ id, action, comment, originalValue }) => {
console.log(id, action, comment, originalValue);
};
</script>
<template>
<Comments :value="value" :onchange="onchange" />
</template>
For "add" operations, the OnChange handler does not provide an id, as the comment may not yet have a unique identifier. For "delete" operations, the comment object is not included, as the comment has already been removed from the data. The originalValue property represents the initial state of the data when the widget was loaded, which could either be a comment stream's ID or the array of comments.
Retrieving the list of comments
The widget allows binding the comments data to a variable, making it possible to access the current state of the comments directly from the component. This is useful for scenarios where the comments need to be further processed or sent to a backend.
<script setup>
import { ref } from 'vue';
import { Comments } from '@svar-ui/vue-comments';
// will contain the current comments array
const data = ref([]);
</script>
<template>
<Comments v-model:value="data" />
</template>
In this example, the value property of the widget is bound to the data variable. This ensures that data always holds the latest array of comments, reflecting any changes made within the widget.
Comment rendering
The widget provides multiple options for rendering comments. It supports rendering plain text, markdown, or custom formatted content. Comments can be displayed in different layouts, such as a text chat, a forum thread, or using custom components. Additional features include setting a custom date format and enabling a readonly mode for viewing comments without interaction.
Rendering custom content for message and text
<script setup>
import { Comments } from "@svar-ui/vue-comments";
import MessageRenderer from "../custom/MessageRenderer.vue";
import ContentRenderer from "../custom/ContentRenderer.vue";
// example data + users
import { getData } from "../data";
const { data, users } = getData();
// convert plain names to mention syntax used by ContentRenderer
data.forEach(d => {
d.content = d.content.replace("Alice", "@[Alice](user:1)");
});
</script>
<template>
<div style="margin: auto; max-width: 700px; margin-top: 40px;">
<Comments
:value="data"
:users="users"
:activeUser="1"
:render="MessageRenderer"
:format="ContentRenderer"
/>
</div>
</template>
ContentRenderer.vue:
<script setup>
const props = defineProps({ content: {} });
const customFormat = text => {
// Convert @mentions: @[Name](user:id) -> <a href="/users/id">Name</a>
return text.replace(
/@\[(.*?)\]\(user:(\d+)\)/g,
'<a href="/users/$2">$1</a>'
);
};
</script>
<template>
<div class="text" v-html="customFormat(props.content)"></div>
</template>
<style scoped>
.text :deep(a) {
color: var(--wx-color-primary);
}
</style>
MessageRenderer.vue:
<script setup>
const props = defineProps({ owned: {}, author: {}, date: {} });
</script>
<template>
<div :class="{ owned: props.owned == props.author.id }" style="padding-left:8px">
<b>{{ props.author.name }}</b> |
<span class="date">{{ props.date.toLocaleString() }}</span>
<slot />
</div>
</template>
<style scoped>
.date {
font-size: var(--wx-font-size-sm);
color: var(--wx-color-font-alt);
}
.owned {
border-left: 2px solid var(--wx-color-primary);
}
</style>
This example demonstrates how to fully customize both the structure of each message and the formatting of the message text.
The render property defines how a message container is displayed (author, timestamp, ownership styling, etc.).
The format property defines how the raw content string of a message is transformed into HTML (e.g., converting mentions into links).
In this setup:
-
MessageRenderer.vuehandles the outer layout of each message. It receives props likeowned(current user ID),author, anddate, and uses a<slot />to render the inner content. This allows you to control the look and feel of the message container. -
ContentRenderer.vueprocesses the text itself. In this example, it replaces patterns like @Alice with clickable links to /users/1. This makes it possible to implement rich formatting rules such as mentions, hashtags, or custom inline markup.
Rendering content in Markdown format
<script setup>
import { Comments } from '@svar-ui/vue-comments';
const value = [
{
id: "1",
content: "Hello, **world**",
author:{ id: 1, name: "John Doe" },
date: new Date(),
},
];
</script>
<template>
<Comments :value="value" format="markdown" />
</template>
This configuration is suitable for content that includes markdown syntax. The widget automatically converts markdown elements like bold, italics, or lists into their respective rendered HTML. Use this when users submit comments in markdown format.
Related sample: Markdown content
Rendering content as plain text
<script setup>
import { Comments } from '@svar-ui/vue-comments';
const value = [
{
id: "1",
content: "Hello, world!",
author:{ id: 1, name: "John Doe" },
date: new Date(),
},
];
</script>
<template>
<Comments :value="value" format="text" />
</template>
This option is designed for cases where the content should be displayed as plain text. No formatting or special syntax is applied, making it suitable for simple comments without any additional styling or processing.
Rendering messages as a text chat
<script setup>
import { Comments } from '@svar-ui/vue-comments';
import { value } from './data.js';
</script>
<template>
<Comments :value="value" render="bubbles" />
</template>
This layout is ideal for rendering comments in a chat-style interface. Messages are displayed as bubbles, providing a modern, conversational look. Use this for applications that aim to replicate a chat or messaging experience.
Rendering messages with a custom component
<script setup>
import { Comments } from '@svar-ui/vue-comments';
import MyMessageRenderer from './MyMessageRenderer.vue';
import { value } from './data.js';
</script>
<template>
<Comments :value="value" :render="MyMessageRenderer" />
</template>
This configuration allows for complete customization of how messages are displayed. By passing a custom Vue component, developers can define unique layouts or styles for each comment. This is useful for highly customized interfaces that require specific visual designs.
Related sample: Custom content
Rendering messages as a forum thread
<script setup>
import { Comments } from '@svar-ui/vue-comments';
import { value } from './data.js';
</script>
<template>
<Comments :value="value" render="flow" />
</template>
This option is designed for displaying comments in a forum thread style. Messages are shown in a linear or hierarchical flow, making it suitable for discussions with replies and nested comments.
Setting the date format for messages
<script setup>
import { Locale } from "@svar-ui/vue-core";
import { Comments } from "@svar-ui/vue-comments";
const myLang = {
dateFormat: "%j. %F %Y %H:%i",
};
</script>
<template>
<Locale :words="{ comments: myLang }">
<Comments />
</Locale>
</template>
This feature allows customization of how dates are displayed in comments. By providing a specific date format, developers can ensure consistency with the application's locale or user preferences.
Displaying the widget in readonly mode
<script setup>
import { Comments } from '@svar-ui/vue-comments';
import { value } from './data.js';
</script>
<template>
<Comments :value="value" :readonly="true" />
</template>
This mode is used when comments should only be viewed but not interacted with. It disables editing, deleting, or adding new comments. This is helpful for scenarios where comments are archived or when users have read-only permissions.
Data management
The widget provides robust support for managing comments data through various methods. Developers can load, save, and manage comments using REST API helpers, local storage, and other custom data sources. These methods cater to different use cases, such as fetching comments, persisting changes, or converting identifiers into data.
Loading and saving comments via REST API
This example demonstrates how to use a REST API helper to load and save comments. The RestURL utility is utilized to fetch data and handle changes to comments.
<script setup>
import { RestURL } from "@svar-ui/lib-data-provider";
import { Comments } from '@svar-ui/vue-comments';
const url = new RestURL("https://some.com/api/comments");
</script>
<template>
<Comments
:ondata="v => url.get(v)"
:onchange="({ action, comment, id, originalValue: v }) =>
url.path(v).save(action, comment, id)"
/>
</template>
In this configuration:
ondatafetches the comments data from the specified REST API endpoint using thegetmethod.onchangehandles any changes to the comments, such as adding, editing, or deleting. Thesavemethod sends the updated data back to the API.- The
RestURLutility simplifies the interaction with RESTful endpoints.
This setup is ideal for projects where comments are managed on a backend server with a REST API.
Related samples:
Saving changes to comments using local storage
This example illustrates how to store and retrieve comments data locally using the browser's local storage.
<script setup>
import { RestURL } from "@svar-ui/lib-data-provider";
import { Comments } from '@svar-ui/vue-comments';
const url = new RestURL("https://some.com/api/comments");
</script>
<template>
<Comments
:value="1"
:ondata="v => localStorage.getItem(`comments-${v}`)"
:onchange="({ value }) =>
localStorage.setItem(`comments-${value}`, JSON.stringify(value))"
/>
</template>
Key details:
ondataretrieves comments from local storage using a unique key associated with the comment stream.onchangesaves the updated comments back into local storage.- The
valueattribute is used as an identifier for the comment stream.
This configuration is useful for offline-first applications or scenarios where comments need to be temporarily stored on the client-side.
Loading comments via REST API
This example focuses on fetching comments data from a REST API without handling changes.
<script setup>
import { RestURL } from "@svar-ui/lib-data-provider";
import { Comments } from '@svar-ui/vue-comments';
const url = new RestURL("https://some.com/api/comments");
</script>
<template>
<Comments :ondata="v => url.get(v)" />
</template>
Details:
ondatafetches the comments data using thegetmethod of theRestURLutility.- This setup is suitable for read-only scenarios where comments need to be displayed but not modified.
Converting comment stream ID to data
This example demonstrates how to map a comment stream identifier to its associated data using a custom fetch implementation.
<script setup>
import { Comments } from '@svar-ui/vue-comments';
const ondata = (v) => {
return fetch(`/api/comments/${v}`).then(r => r.json());
};
</script>
<template>
<Comments :value="1" :ondata="ondata" />
</template>
Key points:
ondatauses thefetchAPI to retrieve comments data from a backend endpoint. The ID of the comment stream is dynamically included in the URL.- The
fetchcall returns a promise that resolves to the comments data.
This approach is flexible and can be adapted for projects with custom backend APIs. The ondata function must return either a data array or a promise resolving to a data array.
Localization
The widget supports localization, enabling it to be displayed in different languages. This is particularly useful for applications targeting users from various linguistic backgrounds. Developers can define custom translations for specific widget terms and phrases.
Localizing the widget to another language
<script setup>
import { Locale } from "@svar-ui/vue-core";
import { Comments } from "@svar-ui/vue-comments";
const myLang = {
Add: "Ajouter",
Edit: "Modifier",
Delete: "Supprimer",
Unknown: "Inconnu",
Me: "Moi",
"Add a comment...": "Ajouter un commentaire..."
};
</script>
<template>
<Locale :words="{ comments: myLang }">
<Comments />
</Locale>
</template>
This example demonstrates how the widget can be localized to French. The myLang constant defines the translations for specific terms used within the widget, such as "Add," "Edit," and "Delete." The Locale component is used to apply these translations by wrapping the Comments widget.
When applied, the widget interface will display the provided French terms instead of the default ones. This ensures a seamless user experience for French-speaking users. It is critical to ensure all necessary terms are translated to avoid displaying untranslated or default text.
Related sample: Locales

Skip to main content

Comments widget

The Comments widget is a component that displays a stream of comments.

It supports rendering in different styles and can display plain text or markdown formatted messages. The widget is capable of rendering existing comments and allows for adding, deleting, or editing previously created comments. It operates entirely on the client-side and can be integrated with any backend service.

This widget is licensed under the MIT license.

Quick start

First steps

To start with the widget, add the necessary package to your project first.

npm install @svar-ui/svelte-core
npm install @svar-ui/svelte-comments

or

yarn add @svar-ui/svelte-core
yarn add @svar-ui/svelte-comments

Now, import the widget into your project.

<script>
import { Willow } from '@svar-ui/svelte-core';
import { Comments } from '@svar-ui/svelte-comments';
</script>

<Willow>
<Comments />
</Willow>

The Willow component is a default theme wrapper that adds necessary styles for all SVAR widgets. The Comments component can function without it, but it will lack styles and require additional styling effort. It is recommended to add the Willow tag once at the top level of your application.

Full init code

To see the widget in action, add some comments to the widget.

<script>
import { Comments, Willow } from '@svar-ui/svelte-comments';

const value = [
{
id: "1",
content: "Hello, world!",
user: 1,
date: new Date(),
},
];

const users = [
{ id: 1, name: "John Doe" },
{ id: 2, name: "Jane Doe" },
];
</script>

<Willow>
<Comments {value} {users} />
</Willow>
note

Make sure you apply a theme if you use the Comments component standalone. Please, refer to applying a theme for more information.

Visual themes

The widget is provided in two visual styles - Light and Dark, controlled by the theme tag.

<script>
import { Willow, WillowDark } from "@svar-ui/svelte-core";
</script>

<!-- Light -->
<Willow>
<Comments />
</Willow>

<!-- Dark -->
<WillowDark>
<Comments />
</WillowDark>

Initialization

The widget provides several methods to initialize and load comments. It supports fetching comments from a backend API, rendering an empty widget, or initializing with predefined data and user information. These options allow flexibility in integrating the widget into different applications and use cases.

Initializing the widget and loading comments

<script>
import { Comments } from '@svar-ui/svelte-comments';

let value = [];

fetch('/api/comments')
.then(r => r.json())
.then(x => value = x);
</script>

{#await value}
<Comments {value} />
{/await}

This approach initializes the widget by fetching comment data from a backend API. It is suitable when the comments are stored on a server and need to be loaded dynamically. The fetch function retrieves the comments in JSON format, which is then passed to the Comments component. The await block ensures the comments are displayed only after the data is successfully loaded.

Initializing an empty comments widget

<script>
import { Comments } from '@svar-ui/svelte-comments';
</script>

<Comments />

This method initializes the widget without any preloaded comments. It is useful when the application starts with no existing comments, allowing users to add new comments from scratch. The component renders a clean interface with no prefilled data.

Initializing the widget with data and a list of users

<script>
import { Comments } from '@svar-ui/svelte-comments';

const value = [
{
id: "1",
content: "Hello, world!",
user: 1,
date: new Date(),
},
];

const users = [
{ id: 1, name: "John Doe" },
{ id: 2, name: "Jane Doe" },
];
</script>

<Comments {value} {users} />

This option initializes the widget with predefined comments and a list of users. Each comment references a user by their ID, and the users array provides the user details. This setup is ideal when the application needs to display comments along with user information, such as names, but the user data is managed separately from the comment data.

Initializing the widget with data and embedded authors

<script>
import { Comments } from '@svar-ui/svelte-comments';

const value = [
{
id: "1",
content: "Hello, world!",
author:{ id: 1, name: "John Doe" },
date: new Date(),
},
];
</script>

<Comments {value} />

This method initializes the widget with predefined comments where the author information is embedded directly within each comment. It is suitable when the application has a compact data structure where user details are stored as part of the comment object. This approach simplifies the data model by combining comments and author details into a single structure.

User interaction

The widget includes methods to handle user comments and interactions. It enables functionalities like defining the current user, auto-focusing the comments editor, tracking changes in data, and retrieving the list of comments.

Defining the current user

The widget allows specifying the currently active user. This is useful for scenarios where specific user comments need to be highlighted or given special permissions, such as editing or deleting. Comments from the active user can have distinct styling for better visual differentiation.

<script>
import { Comments } from '@svar-ui/svelte-comments';

const users = [
{ id: 1, name: "John Doe" },
{ id: 2, name: "Jane Doe" },
];
</script>

<Comments {value} {users} activeUser={1} />

In this example, the activeUser property is set to 1, indicating that the user with id: 1 is the current user. Their comments can be edited or deleted through the UI and can have separate styling applied to them.

Auto-focusing the comments Editor

The widget provides the ability to automatically focus the comments editor when it is rendered. This is particularly useful for use-cases where the widget is integrated into a page that prioritizes user input, such as a discussion forum or a feedback form.

<script>
import { Comments } from '@svar-ui/svelte-comments';
</script>

<Comments focus={true} />

By setting the focus property to true, the input field for adding a comment will be automatically focused after the widget is rendered.

Tracking data changes

The widget supports monitoring changes to the comments data. It provides detailed information about the type of change (add, update, or delete), the specific comment affected, and the state of the data before and after the change. This functionality is essential for implementing features like real-time updates, logging, or syncing with a backend.

interface OnChange {
// kind of change
action: "add" | "update" | "delete";
// id of changed comment
id?: number;
// changed comment
comment?: Comment;
// current comments data
data: Comment[];
// original comments data
originalValue: Comment[] | number | string;
}
<script>
import { Comments } from '@svar-ui/svelte-comments';
import { value } from './data.js';

const onchange = ({ id, action, comment, originalValue }) => {
console.log(id, action, comment, originalValue);
};
</script>

<Comments {value} {onchange} />

For "add" operations, the OnChange handler does not provide an id, as the comment may not yet have a unique identifier. For "delete" operations, the comment object is not included, as the comment has already been removed from the data. The originalValue property represents the initial state of the data when the widget was loaded, which could either be a comment stream's ID or the array of comments.

Retrieving the list of comments

The widget allows binding the comments data to a variable, making it possible to access the current state of the comments directly from the component. This is useful for scenarios where the comments need to be further processed or sent to a backend.

<script>
import { Comments } from '@svar-ui/svelte-comments';

// will contain the current comments array
let data = [];
</script>

<Comments bind:value={data} />

In this example, the value property of the widget is bound to the data variable. This ensures that data always holds the latest array of comments, reflecting any changes made within the widget.

Comment rendering

The widget provides multiple options for rendering comments. It supports rendering plain text, markdown, or custom formatted content. Comments can be displayed in different layouts, such as a text chat, a forum thread, or using custom components. Additional features include setting a custom date format and enabling a readonly mode for viewing comments without interaction.

Rendering custom content for message and text

<script>
import { Comments } from "@svar-ui/svelte-comments";
import MessageRenderer from "../custom/MessageRenderer.svelte";
import ContentRenderer from "../custom/ContentRenderer.svelte";

// example data + users
import { getData } from "../data";
const { data, users } = getData();

// convert plain names to mention syntax used by ContentRenderer
data.forEach(d => {
d.content = d.content.replace("Alice", "@[Alice](user:1)");
});
</script>

<div style="margin: auto; max-width: 700px; margin-top: 40px;">
<Comments
value={data}
{users}
activeUser={1}
render={MessageRenderer}
format={ContentRenderer}
/>
</div>

ContentRenderer.svelte:

<script>
let { content } = $props();

const customFormat = text => {
// Convert @mentions: @[Name](user:id) -> <a href="/users/id">Name</a>
return text.replace(
/@\[(.*?)\]\(user:(\d+)\)/g,
'<a href="/users/$2">$1</a>'
);
};
</script>

<div class="text">
{@html customFormat(content)}
</div>

<style>
.text :global(a) {
color: var(--wx-color-primary);
}
</style>

MessageRenderer.svelte:

<script>
let { owned, author, date, children } = $props();
</script>

<div class:owned={owned == author.id} style="padding-left:8px">
<b>{author.name}</b> |
<span class="date">{date.toLocaleString()}</span>
{@render children()}
</div>

<style>
.date {
font-size: var(--wx-font-size-sm);
color: var(--wx-color-font-alt);
}
.owned {
border-left: 2px solid var(--wx-color-primary);
}
</style>

This example demonstrates how to fully customize both the structure of each message and the formatting of the message text.

The render property defines how a message container is displayed (author, timestamp, ownership styling, etc.).

The format property defines how the raw content string of a message is transformed into HTML (e.g., converting mentions into links).

In this setup:

  • MessageRenderer.svelte handles the outer layout of each message. It receives props like owned (current user ID), author, and date, and uses @render children() to render the inner content. This allows you to control the look and feel of the message container.

  • ContentRenderer.svelte processes the text itself. In this example, it replaces patterns like @Alice with clickable links to /users/1. This makes it possible to implement rich formatting rules such as mentions, hashtags, or custom inline markup.

Rendering content in Markdown format

<script>
import { Comments } from '@svar-ui/svelte-comments';

const value = [
{
id: "1",
content: "Hello, **world**",
author:{ id: 1, name: "John Doe" },
date: new Date(),
},
];
</script>

<Comments {value} format="markdown" />

This configuration is suitable for content that includes markdown syntax. The widget automatically converts markdown elements like bold, italics, or lists into their respective rendered HTML. Use this when users submit comments in markdown format.

Related sample: Markdown content

Rendering content as plain text

<script>
import { Comments } from '@svar-ui/svelte-comments';

const value = [
{
id: "1",
content: "Hello, world!",
author:{ id: 1, name: "John Doe" },
date: new Date(),
},
];
</script>

<Comments {value} format="text" />

This option is designed for cases where the content should be displayed as plain text. No formatting or special syntax is applied, making it suitable for simple comments without any additional styling or processing.

Rendering messages as a text chat

<script>
import { Comments } from '@svar-ui/svelte-comments';
import { value } from './data.js';
</script>

<Comments {value} render="bubbles" />

This layout is ideal for rendering comments in a chat-style interface. Messages are displayed as bubbles, providing a modern, conversational look. Use this for applications that aim to replicate a chat or messaging experience.

Rendering messages with a custom component

<script>
import { Comments } from '@svar-ui/svelte-comments';
import { MyMessageRenderer } from './MyMessageRenderer.svelte';
import { value } from './data.js';
</script>

<Comments {value} render={MyMessageRenderer} />

This configuration allows for complete customization of how messages are displayed. By passing a custom Svelte component, developers can define unique layouts or styles for each comment. This is useful for highly customized interfaces that require specific visual designs.

Related sample: Custom content

Rendering messages as a forum thread

<script>
import { Comments } from '@svar-ui/svelte-comments';
import { value } from './data.js';
</script>

<Comments {value} render="flow" />

This option is designed for displaying comments in a forum thread style. Messages are shown in a linear or hierarchical flow, making it suitable for discussions with replies and nested comments.

Setting the date format for messages

<script>
import { Locale } from "@svar-ui/svelte-core";
import { Comments } from "@svar-ui/svelte-comments";

const myLang = {
dateFormat: "%j. %F %Y %H:%i",
};
</script>

<Locale words={{ comments:myLang }}>
<Comments />
</Locale>

This feature allows customization of how dates are displayed in comments. By providing a specific date format, developers can ensure consistency with the application's locale or user preferences.

Displaying the widget in readonly mode

<script>
import { Comments } from '@svar-ui/svelte-comments';
import { value } from './data.js';
</script>

<Comments {value} readonly={true} />

This mode is used when comments should only be viewed but not interacted with. It disables editing, deleting, or adding new comments. This is helpful for scenarios where comments are archived or when users have read-only permissions.

Data management

The widget provides robust support for managing comments data through various methods. Developers can load, save, and manage comments using REST API helpers, local storage, and other custom data sources. These methods cater to different use cases, such as fetching comments, persisting changes, or converting identifiers into data.

Loading and saving comments via REST API

This example demonstrates how to use a REST API helper to load and save comments. The RestURL utility is utilized to fetch data and handle changes to comments.

<script>
import { RestURL } from "@svar-ui/lib-data-provider";
import { Comments } from '@svar-ui/svelte-comments';

const url = new RestURL("https://some.com/api/comments");
</script>

<Comments
ondata={v => url.get(v)}
onchange={({ action, comment, id, originalValue: v }) =>
url.path(v).save(action, comment, id)}
/>

In this configuration:

  • ondata fetches the comments data from the specified REST API endpoint using the get method.
  • onchange handles any changes to the comments, such as adding, editing, or deleting. The save method sends the updated data back to the API.
  • The RestURL utility simplifies the interaction with RESTful endpoints.

This setup is ideal for projects where comments are managed on a backend server with a REST API.

Related samples:

Saving changes to comments using local storage

This example illustrates how to store and retrieve comments data locally using the browser's local storage.

<script>
import { RestURL } from "@svar-ui/lib-data-provider";
import { Comments } from '@svar-ui/svelte-comments';

const url = new RestURL("https://some.com/api/comments");
</script>

<Comments
value={1}
ondata={v => localStorage.getItem(`comments-${v}`)}
onchange={({ value }) =>
localStorage.setItem(`comments-${value}`, JSON.stringify(value))}
/>

Key details:

  • ondata retrieves comments from local storage using a unique key associated with the comment stream.
  • onchange saves the updated comments back into local storage.
  • The value attribute is used as an identifier for the comment stream.

This configuration is useful for offline-first applications or scenarios where comments need to be temporarily stored on the client-side.

Loading comments via REST API

This example focuses on fetching comments data from a REST API without handling changes.

<script>
import { RestURL } from "svar-ui/lib-data-provider";
import { Comments } from '@svar-ui/svelte-comments';

const url = new RestURL("https://some.com/api/comments");
</script>

<Comments ondata={v => url.get(v)} />

Details:

  • ondata fetches the comments data using the get method of the RestURL utility.
  • This setup is suitable for read-only scenarios where comments need to be displayed but not modified.

Converting comment stream ID to data

This example demonstrates how to map a comment stream identifier to its associated data using a custom fetch implementation.

<script>
import { Comments } from '@svar-ui/svelte-comments';

const ondata = (v) => {
return fetch(`/api/comments/${v}`).then(r => r.json());
};
</script>

<Comments value={1} {ondata} />

Key points:

  • ondata uses the fetch API to retrieve comments data from a backend endpoint. The ID of the comment stream is dynamically included in the URL.
  • The fetch call returns a promise that resolves to the comments data.

This approach is flexible and can be adapted for projects with custom backend APIs. The ondata function must return either a data array or a promise resolving to a data array.

Localization

The widget supports localization, enabling it to be displayed in different languages. This is particularly useful for applications targeting users from various linguistic backgrounds. Developers can define custom translations for specific widget terms and phrases.

Localizing the widget to another language

<script>
import { Locale } from "@svar-ui/svelte-core";
import { Comments } from "@svar-ui/svelte-comments";

const myLang = {
Add: "Ajouter",
Edit: "Modifier",
Delete: "Supprimer",
Unknown: "Inconnu",
Me: "Moi",
"Add a comment...": "Ajouter un commentaire..."
};
</script>

<Locale words={{ comments:myLang }}>
<Comments />
</Locale>

This example demonstrates how the widget can be localized to French. The myLang constant defines the translations for specific terms used within the widget, such as "Add," "Edit," and "Delete." The Locale component is used to apply these translations by wrapping the Comments widget.

When applied, the widget interface will display the provided French terms instead of the default ones. This ensures a seamless user experience for French-speaking users. It is critical to ensure all necessary terms are translated to avoid displaying untranslated or default text.

Related sample: Locales

Samples

Other Comments samples

Comments widget
The Comments widget is a component that displays a stream of comments.
It supports rendering in different styles and can display plain text or markdown formatted messages. The widget is capable of rendering existing comments and allows for adding, deleting, or editing previously created comments. It operates entirely on the client-side and can be integrated with any backend service.
This widget is licensed under the MIT license.
Quick start
First steps
To start with the widget, add the necessary package to your project first.
npm install @svar-ui/react-core
npm install @svar-ui/react-comments
or
yarn add @svar-ui/react-core
yarn add @svar-ui/react-comments
Now, import the widget into your project.
import { Willow } from '@svar-ui/react-core';
import { Comments } from '@svar-ui/react-comments';
<Willow>
<Comments />
</Willow>
The Willow component is a default theme wrapper that adds necessary styles for all SVAR widgets. The Comments component can function without it, but it will lack styles and require additional styling effort. It is recommended to add the Willow tag once at the top level of your application.
Full init code
To see the widget in action, add some comments to the widget.
import { Willow } from '@svar-ui/react-core';
import { Comments } from '@svar-ui/react-comments';
const value = [
{
id: "1",
content: "Hello, world!",
user: 1,
date: new Date(),
},
];
const users = [
{ id: 1, name: "John Doe" },
{ id: 2, name: "Jane Doe" },
];
<Willow>
<Comments value={value} users={users} />
</Willow>
Make sure you apply a theme if you use the Comments component standalone. Please, refer to applying a theme for more information.
Visual themes
The widget is provided in two visual styles - Light and Dark, controlled by the theme tag.
import { Willow, WillowDark } from "@svar-ui/react-core";
{/* Light */}
<Willow>
<Comments />
</Willow>
{/* Dark */}
<WillowDark>
<Comments />
</WillowDark>
Initialization
The widget provides several methods to initialize and load comments. It supports fetching comments from a backend API, rendering an empty widget, or initializing with predefined data and user information. These options allow flexibility in integrating the widget into different applications and use cases.
Initializing the widget and loading comments
import { useEffect, useState } from 'react';
import { Comments } from '@svar-ui/react-comments';
function Example() {
const [value, setValue] = useState(null);
useEffect(() => {
fetch('/api/comments')
.then(r => r.json())
.then(x => setValue(x));
}, []);
if (value === null) return <div>Loading...</div>;
return <Comments value={value} />;
}
This approach initializes the widget by fetching comment data from a backend API. It is suitable when the comments are stored on a server and need to be loaded dynamically. The fetch function retrieves the comments in JSON format, which is then passed to the Comments component. The component is rendered only after the data is successfully loaded.
Initializing an empty comments widget
import { Comments } from '@svar-ui/react-comments';
<Comments />
This method initializes the widget without any preloaded comments. It is useful when the application starts with no existing comments, allowing users to add new comments from scratch. The component renders a clean interface with no prefilled data.
Initializing the widget with data and a list of users
import { Comments } from '@svar-ui/react-comments';
const value = [
{
id: "1",
content: "Hello, world!",
user: 1,
date: new Date(),
},
];
const users = [
{ id: 1, name: "John Doe" },
{ id: 2, name: "Jane Doe" },
];
<Comments value={value} users={users} />
This option initializes the widget with predefined comments and a list of users. Each comment references a user by their ID, and the users array provides the user details. This setup is ideal when the application needs to display comments along with user information, such as names, but the user data is managed separately from the comment data.
Initializing the widget with data and embedded authors
import { Comments } from '@svar-ui/react-comments';
const value = [
{
id: "1",
content: "Hello, world!",
author: { id: 1, name: "John Doe" },
date: new Date(),
},
];
<Comments value={value} />
This method initializes the widget with predefined comments where the author information is embedded directly within each comment. It is suitable when the application has a compact data structure where user details are stored as part of the comment object. This approach simplifies the data model by combining comments and author details into a single structure.
User interaction
The widget includes methods to handle user comments and interactions. It enables functionalities like defining the current user, auto-focusing the comments editor, tracking changes in data, and retrieving the list of comments.
Defining the current user
The widget allows specifying the currently active user. This is useful for scenarios where specific user comments need to be highlighted or given special permissions, such as editing or deleting. Comments from the active user can have distinct styling for better visual differentiation.
import { Comments } from '@svar-ui/react-comments';
const users = [
{ id: 1, name: "John Doe" },
{ id: 2, name: "Jane Doe" },
];
<Comments value={value} users={users} activeUser={1} />
In this example, the activeUser property is set to 1, indicating that the user with id: 1 is the current user. Their comments can be edited or deleted through the UI and can have separate styling applied to them.
Auto-focusing the comments Editor
The widget provides the ability to automatically focus the comments editor when it is rendered. This is particularly useful for use-cases where the widget is integrated into a page that prioritizes user input, such as a discussion forum or a feedback form.
import { Comments } from '@svar-ui/react-comments';
<Comments focus={true} />
By setting the focus property to true, the input field for adding a comment will be automatically focused after the widget is rendered.
Tracking data changes
The widget supports monitoring changes to the comments data. It provides detailed information about the type of change (add, update, or delete), the specific comment affected, and the state of the data before and after the change. This functionality is essential for implementing features like real-time updates, logging, or syncing with a backend.
interface OnChange {
// kind of change
action: "add" | "update" | "delete";
// id of changed comment
id?: number;
// changed comment
comment?: Comment;
// current comments data
data: Comment[];
// original comments data
originalValue: Comment[] | number | string;
}
import { Comments } from '@svar-ui/react-comments';
import { value } from './data.js';
const handleChange = ({ id, action, comment, originalValue }) => {
console.log(id, action, comment, originalValue);
};
<Comments value={value} onChange={handleChange} />
For "add" operations, the OnChange handler does not provide an id, as the comment may not yet have a unique identifier. For "delete" operations, the comment object is not included, as the comment has already been removed from the data. The originalValue property represents the initial state of the data when the widget was loaded, which could either be a comment stream's ID or the array of comments.
Retrieving the list of comments
Use the controlled pattern in React: provide value and update it from onChange.
import { useState } from 'react';
import { Comments } from '@svar-ui/react-comments';
function Example() {
const [data, setData] = useState([]);
return (
<Comments
value={data}
onChange={({ data: newData }) => setData(newData)}
/>
);
}
In this example, the component state data always holds the latest array of comments, reflecting any changes made within the Comments widget.
Comment rendering
The widget provides multiple options for rendering comments. It supports rendering plain text, markdown, or custom formatted content. Comments can be displayed in different layouts, such as a text chat, a forum thread, or using custom components. Additional features include setting a custom date format and enabling a readonly mode for viewing comments without interaction.
Rendering custom content for message and text
import { Comments } from "@svar-ui/react-comments";
import MessageRenderer from "../custom/MessageRenderer.jsx";
import ContentRenderer from "../custom/ContentRenderer.jsx";
// example data + users
import { getData } from "../data";
const { data, users } = getData();
// convert plain names to mention syntax used by ContentRenderer
data.forEach(d => {
d.content = d.content.replace("Alice", "@[Alice](user:1)");
});
<div style={{ margin: "auto", maxWidth: 700, marginTop: 40 }}>
<Comments
value={data}
users={users}
activeUser={1}
render={MessageRenderer}
format={ContentRenderer}
/>
</div>
ContentRenderer.jsx:
function ContentRenderer({ content }) {
const customFormat = (text) =>
// Convert @mentions: @[Name](user:id) -> <a href="/users/id">Name</a>
text.replace(/@\[(.*?)\]\(user:(\d+)\)/g, '<a href="/users/$2">$1</a>');
return <div className="text" dangerouslySetInnerHTML={{ __html: customFormat(content) }} />;
}
export default ContentRenderer;
/* where styles defined like follows */
.text a {
color: var(--wx-color-primary);
}
MessageRenderer.jsx:
function MessageRenderer({ owned, author, date, children }) {
return (
<div className={owned == author.id ? "owned" : ""} style={{ paddingLeft: 8 }}>
<b>{author.name}</b> | <span className="date">{date.toLocaleString()}</span>
{typeof children === "function" ? children() : children}
</div>
);
}
export default MessageRenderer;
/* where styles defined like follows */
.date {
font-size: var(--wx-font-size-sm);
color: var(--wx-color-font-alt);
}
.owned {
border-left: 2px solid var(--wx-color-primary);
}
This example demonstrates how to fully customize both the structure of each message and the formatting of the message text.
The render property defines how a message container is displayed (author, timestamp, ownership styling, etc.).
The format property defines how the raw content string of a message is transformed into HTML (e.g., converting mentions into links).
In this setup:
-
MessageRenderer.jsxhandles the outer layout of each message. It receives props likeowned(current user ID),author, anddate, and uses thechildrenrender-prop to render the inner content. This allows you to control the look and feel of the message container. -
ContentRenderer.jsxprocesses the text itself. In this example, it replaces patterns like @Alice with clickable links to /users/1. This makes it possible to implement rich formatting rules such as mentions, hashtags, or custom inline markup.
Rendering content in Markdown format
import { Comments } from '@svar-ui/react-comments';
const value = [
{
id: "1",
content: "Hello, **world**",
author: { id: 1, name: "John Doe" },
date: new Date(),
},
];
<Comments value={value} format="markdown" />
This configuration is suitable for content that includes markdown syntax. The widget automatically converts markdown elements like bold, italics, or lists into their respective rendered HTML. Use this when users submit comments in markdown format.
Related sample: Markdown content
Rendering content as plain text
import { Comments } from '@svar-ui/react-comments';
const value = [
{
id: "1",
content: "Hello, world!",
author: { id: 1, name: "John Doe" },
date: new Date(),
},
];
<Comments value={value} format="text" />
This option is designed for cases where the content should be displayed as plain text. No formatting or special syntax is applied, making it suitable for simple comments without any additional styling or processing.
Rendering messages as a text chat
import { Comments } from '@svar-ui/react-comments';
import { value } from './data.js';
<Comments value={value} render="bubbles" />
This layout is ideal for rendering comments in a chat-style interface. Messages are displayed as bubbles, providing a modern, conversational look. Use this for applications that aim to replicate a chat or messaging experience.
Rendering messages with a custom component
import { Comments } from '@svar-ui/react-comments';
import MyMessageRenderer from './MyMessageRenderer.jsx';
import { value } from './data.js';
<Comments value={value} render={MyMessageRenderer} />
This configuration allows for complete customization of how messages are displayed. By passing a custom React component, developers can define unique layouts or styles for each comment. This is useful for highly customized interfaces that require specific visual designs.
Related sample: Custom content
Rendering messages as a forum thread
import { Comments } from '@svar-ui/react-comments';
import { value } from './data.js';
<Comments value={value} render="flow" />
This option is designed for displaying comments in a forum thread style. Messages are shown in a linear or hierarchical flow, making it suitable for discussions with replies and nested comments.
Setting the date format for messages
import { Locale } from "@svar-ui/react-core";
import { Comments } from "@svar-ui/react-comments";
const myLang = {
dateFormat: "%j. %F %Y %H:%i",
};
<Locale words={{ comments: myLang }}>
<Comments />
</Locale>
This feature allows customization of how dates are displayed in comments. By providing a specific date format, developers can ensure consistency with the application's locale or user preferences.
Displaying the widget in readonly mode
import { Comments } from '@svar-ui/react-comments';
import { value } from './data.js';
<Comments value={value} readonly={true} />
This mode is used when comments should only be viewed but not interacted with. It disables editing, deleting, or adding new comments. This is helpful for scenarios where comments are archived or when users have read-only permissions.
Data management
The widget provides robust support for managing comments data through various methods. Developers can load, save, and manage comments using REST API helpers, local storage, and other custom data sources. These methods cater to different use cases, such as fetching comments, persisting changes, or converting identifiers into data.
Loading and saving comments via REST API
This example demonstrates how to use a REST API helper to load and save comments. The RestURL utility is utilized to fetch data and handle changes to comments.
import { RestURL } from "@svar-ui/lib-data-provider";
import { Comments } from '@svar-ui/react-comments';
const url = new RestURL("https://some.com/api/comments");
<Comments
onData={v => url.get(v)}
onChange={({ action, comment, id, originalValue: v }) =>
url.path(v).save(action, comment, id)}
/>
In this configuration:
onDatafetches the comments data from the specified REST API endpoint using thegetmethod.onChangehandles any changes to the comments, such as adding, editing, or deleting. Thesavemethod sends the updated data back to the API.- The
RestURLutility simplifies the interaction with RESTful endpoints.
This setup is ideal for projects where comments are managed on a backend server with a REST API.
Related samples:
Saving changes to comments using local storage
This example illustrates how to store and retrieve comments data locally using the browser's local storage.
import { Comments } from '@svar-ui/react-comments';
<Comments
value={1}
onData={v => JSON.parse(localStorage.getItem(`comments-${v}`))}
onChange={({ value }) =>
localStorage.setItem(`comments-${value}`, JSON.stringify(value))}
/>
Key details:
onDataretrieves comments from local storage using a unique key associated with the comment stream.onChangesaves the updated comments back into local storage.- The
valueattribute is used as an identifier for the comment stream.
This configuration is useful for offline-first applications or scenarios where comments need to be temporarily stored on the client-side.
Loading comments via REST API
This example focuses on fetching comments data from a REST API without handling changes.
import { RestURL } from "@svar-ui/lib-data-provider";
import { Comments } from '@svar-ui/react-comments';
const url = new RestURL("https://some.com/api/comments");
<Comments onData={v => url.get(v)} />
Details:
onDatafetches the comments data using thegetmethod of theRestURLutility.- This setup is suitable for read-only scenarios where comments need to be displayed but not modified.
Converting comment stream ID to data
This example demonstrates how to map a comment stream identifier to its associated data using a custom fetch implementation.
import { Comments } from '@svar-ui/react-comments';
const onData = (v) => fetch(`/api/comments/${v}`).then(r => r.json());
<Comments value={1} onData={onData} />
Key points:
onDatauses thefetchAPI to retrieve comments data from a backend endpoint. The ID of the comment stream is dynamically included in the URL.- The
fetchcall returns a promise that resolves to the comments data.
This approach is flexible and can be adapted for projects with custom backend APIs. The onData function must return either a data array or a promise resolving to a data array.
Localization
The widget supports localization, enabling it to be displayed in different languages. This is particularly useful for applications targeting users from various linguistic backgrounds. Developers can define custom translations for specific widget terms and phrases.
Localizing the widget to another language
import { Locale } from "@svar-ui/react-core";
import { Comments } from "@svar-ui/react-comments";
const myLang = {
Add: "Ajouter",
Edit: "Modifier",
Delete: "Supprimer",
Unknown: "Inconnu",
Me: "Moi",
"Add a comment...": "Ajouter un commentaire..."
};
<Locale words={{ comments: myLang }}>
<Comments />
</Locale>
This example demonstrates how the widget can be localized to French. The myLang constant defines the translations for specific terms used within the widget, such as "Add," "Edit," and "Delete." The Locale component is used to apply these translations by wrapping the Comments widget.
When applied, the widget interface will display the provided French terms instead of the default ones. This ensures a seamless user experience for French-speaking users. It is critical to ensure all necessary terms are translated to avoid displaying untranslated or default text.
Related sample: Locales